import { gl_Colors } from '@/hook/wave-view/render-utils';
import { reactive } from 'vue';

// 用于管理当前信号 link 和对应颜色索引的映射关系
// 如果 link 不在下表中，则使用默认的颜色索引
// 默认颜色请参考 render-utils.js 中有关 gl_Colors_template 的定义
export const userSignalColorMap = new Map();

// 当前选中波形目前的颜色
export const colorPickerManage = reactive({
    currentSelecteIndex: -1
});

/**
 * 
 * @param {WireItem} signal 
 */
export function updateColorPickerManage(signal) {
    if (userSignalColorMap.has(signal.link)) {
        colorPickerManage.currentSelecteIndex = userSignalColorMap.get(signal.link);
    } else {
        // 找到默认的配色
        if (signal.size === 1) {
            colorPickerManage.currentSelecteIndex = 2;
        } else {
            colorPickerManage.currentSelecteIndex = 5;
        }
    }
}

