import { globalLookup } from './global';

let changeView = globalLookup.view;
const config = {
    maxScale: 1000,
    minScale: 0.01,
    scaleInterval: 0.1
}

/**
 * 
 * @param {WheelEvent} event 
 */
function wheelScale(event) {
    // 鼠标滚轮往下是收缩， 往上是变大
    if (event.deltaY > 0) {
        const laterScale = changeView.currentScaleX + config.scaleInterval;
        if (laterScale <= config.maxScale) {
            changeView.currentScaleX = laterScale;
            document.body.style.setProperty('--render-scale-x', laterScale);
        }
    } else if (event.deltaY < 0) {
        const laterScale = changeView.currentScaleX - config.scaleInterval;
        if (laterScale >= config.minScale) {
            changeView.currentScaleX = laterScale;
            document.body.style.setProperty('--render-scale-x', laterScale);
        }
    }
}

/**
 * 
 * @param {WheelEvent} event 
 */
function wheelTranslate(event) {

}


export {
    wheelScale,
    wheelTranslate
};